# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Hdinsight::Mgmt::V2018_06_01_preview
  module Models
    #
    # The response for the operation to get regional billingSpecs for a
    # subscription.
    #
    class BillingResponseListResult

      include MsRestAzure

      # @return [Array<String>] The virtual machine sizes to include or
      # exclude.
      attr_accessor :vm_sizes

      # @return [Array<String>] The vm sizes which enable encryption at host.
      attr_accessor :vm_sizes_with_encryption_at_host

      # @return [Array<VmSizeCompatibilityFilterV2>] The virtual machine
      # filtering mode. Effectively this can enabling or disabling the virtual
      # machine sizes in a particular set.
      attr_accessor :vm_size_filters

      # @return [Array<VmSizeProperty>] The vm size properties.
      attr_accessor :vm_size_properties

      # @return [Array<BillingResources>] The billing and managed disk billing
      # resources for a region.
      attr_accessor :billing_resources


      #
      # Mapper for BillingResponseListResult class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'BillingResponseListResult',
          type: {
            name: 'Composite',
            class_name: 'BillingResponseListResult',
            model_properties: {
              vm_sizes: {
                client_side_validation: true,
                required: false,
                serialized_name: 'vmSizes',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              vm_sizes_with_encryption_at_host: {
                client_side_validation: true,
                required: false,
                serialized_name: 'vmSizesWithEncryptionAtHost',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              vm_size_filters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'vmSizeFilters',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'VmSizeCompatibilityFilterV2ElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'VmSizeCompatibilityFilterV2'
                      }
                  }
                }
              },
              vm_size_properties: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'vmSizeProperties',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'VmSizePropertyElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'VmSizeProperty'
                      }
                  }
                }
              },
              billing_resources: {
                client_side_validation: true,
                required: false,
                serialized_name: 'billingResources',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'BillingResourcesElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'BillingResources'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
