# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Hdinsight::Mgmt::V2018_06_01_preview
  module Models
    #
    # The details of metric specifications.
    #
    class MetricSpecifications

      include MsRestAzure

      # @return [String] The name of the metric specification.
      attr_accessor :name

      # @return [String] The display name of the metric specification.
      attr_accessor :display_name

      # @return [String] The display description of the metric specification.
      attr_accessor :display_description

      # @return [String] The unit of the metric specification.
      attr_accessor :unit

      # @return [String] The aggregation type of the metric specification.
      attr_accessor :aggregation_type

      # @return [Array<String>] The supported aggregation types of the metric
      # specification.
      attr_accessor :supported_aggregation_types

      # @return [Array<String>] The supported time grain types of the metric
      # specification.
      attr_accessor :supported_time_grain_types

      # @return [Boolean] The flag indicates whether enable regional mdm
      # account or not.
      attr_accessor :enable_regional_mdm_account

      # @return [String] The source mdm account.
      attr_accessor :source_mdm_account

      # @return [String] The source mdm namespace.
      attr_accessor :source_mdm_namespace

      # @return [String] The metric filter pattern.
      attr_accessor :metric_filter_pattern

      # @return [Boolean] The flag indicates whether filling gap with zero.
      attr_accessor :fill_gap_with_zero

      # @return [String] The category of the metric.
      attr_accessor :category

      # @return [String] The override name of resource id dimension name.
      attr_accessor :resource_id_dimension_name_override

      # @return [Boolean] The flag indicates whether the metric is internal or
      # not.
      attr_accessor :is_internal

      # @return [String] The override name of delegate metric.
      attr_accessor :delegate_metric_name_override

      # @return [Array<Dimension>] The dimensions of the metric specification.
      attr_accessor :dimensions


      #
      # Mapper for MetricSpecifications class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'MetricSpecifications',
          type: {
            name: 'Composite',
            class_name: 'MetricSpecifications',
            model_properties: {
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              display_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'displayName',
                type: {
                  name: 'String'
                }
              },
              display_description: {
                client_side_validation: true,
                required: false,
                serialized_name: 'displayDescription',
                type: {
                  name: 'String'
                }
              },
              unit: {
                client_side_validation: true,
                required: false,
                serialized_name: 'unit',
                type: {
                  name: 'String'
                }
              },
              aggregation_type: {
                client_side_validation: true,
                required: false,
                serialized_name: 'aggregationType',
                type: {
                  name: 'String'
                }
              },
              supported_aggregation_types: {
                client_side_validation: true,
                required: false,
                serialized_name: 'supportedAggregationTypes',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              supported_time_grain_types: {
                client_side_validation: true,
                required: false,
                serialized_name: 'supportedTimeGrainTypes',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              enable_regional_mdm_account: {
                client_side_validation: true,
                required: false,
                serialized_name: 'enableRegionalMdmAccount',
                type: {
                  name: 'Boolean'
                }
              },
              source_mdm_account: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sourceMdmAccount',
                type: {
                  name: 'String'
                }
              },
              source_mdm_namespace: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sourceMdmNamespace',
                type: {
                  name: 'String'
                }
              },
              metric_filter_pattern: {
                client_side_validation: true,
                required: false,
                serialized_name: 'metricFilterPattern',
                type: {
                  name: 'String'
                }
              },
              fill_gap_with_zero: {
                client_side_validation: true,
                required: false,
                serialized_name: 'fillGapWithZero',
                type: {
                  name: 'Boolean'
                }
              },
              category: {
                client_side_validation: true,
                required: false,
                serialized_name: 'category',
                type: {
                  name: 'String'
                }
              },
              resource_id_dimension_name_override: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourceIdDimensionNameOverride',
                type: {
                  name: 'String'
                }
              },
              is_internal: {
                client_side_validation: true,
                required: false,
                serialized_name: 'isInternal',
                type: {
                  name: 'Boolean'
                }
              },
              delegate_metric_name_override: {
                client_side_validation: true,
                required: false,
                serialized_name: 'delegateMetricNameOverride',
                type: {
                  name: 'String'
                }
              },
              dimensions: {
                client_side_validation: true,
                required: false,
                serialized_name: 'dimensions',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'DimensionElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'Dimension'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
