# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Hdinsight::Mgmt::V2018_06_01_preview
  module Models
    #
    # The storage Account.
    #
    class StorageAccount

      include MsRestAzure

      # @return [String] The name of the storage account.
      attr_accessor :name

      # @return [Boolean] Whether or not the storage account is the default
      # storage account.
      attr_accessor :is_default

      # @return [String] The container in the storage account, only to be
      # specified for WASB storage accounts.
      attr_accessor :container

      # @return [String] The filesystem, only to be specified for Azure Data
      # Lake Storage Gen 2.
      attr_accessor :file_system

      # @return [String] The storage account access key.
      attr_accessor :key

      # @return [String] The resource ID of storage account, only to be
      # specified for Azure Data Lake Storage Gen 2.
      attr_accessor :resource_id

      # @return [String] The managed identity (MSI) that is allowed to access
      # the storage account, only to be specified for Azure Data Lake Storage
      # Gen 2.
      attr_accessor :msi_resource_id

      # @return [String] The shared access signature key.
      attr_accessor :saskey

      # @return [String] The file share name.
      attr_accessor :fileshare


      #
      # Mapper for StorageAccount class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'StorageAccount',
          type: {
            name: 'Composite',
            class_name: 'StorageAccount',
            model_properties: {
              name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              is_default: {
                client_side_validation: true,
                required: false,
                serialized_name: 'isDefault',
                type: {
                  name: 'Boolean'
                }
              },
              container: {
                client_side_validation: true,
                required: false,
                serialized_name: 'container',
                type: {
                  name: 'String'
                }
              },
              file_system: {
                client_side_validation: true,
                required: false,
                serialized_name: 'fileSystem',
                type: {
                  name: 'String'
                }
              },
              key: {
                client_side_validation: true,
                required: false,
                serialized_name: 'key',
                type: {
                  name: 'String'
                }
              },
              resource_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'resourceId',
                type: {
                  name: 'String'
                }
              },
              msi_resource_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'msiResourceId',
                type: {
                  name: 'String'
                }
              },
              saskey: {
                client_side_validation: true,
                required: false,
                serialized_name: 'saskey',
                type: {
                  name: 'String'
                }
              },
              fileshare: {
                client_side_validation: true,
                required: false,
                serialized_name: 'fileshare',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
